package com.subd.subd.Repositories;

import com.subd.subd.Models.Order;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.Date;
import java.util.List;

public interface OrderRepository extends JpaRepository<Order, Long> {
    @Query(value = "SELECT \"order\".ID, \"order\".DATE, \"order\".STATUS, \"car\".GOS_NUMBER, \"driver\".NAME as driver_name, \"client\".NAME as client_name\n" +
            "FROM \"order\"\n" +
            "JOIN CAR ON CAR.ID = \"order\".CAR_ID\n" +
            "JOIN DRIVER ON CAR.DRIVER_ID = DRIVER.ID\n" +
            "JOIN CLIENT ON CLIENT.ID = \"order\".CLIENT_ID\n" +
            "WHERE \"order\".DATE > :date AND \"order\".VALUE > :value AND \"order\".STATUS like :status\n" +
            "ORDER BY :orderBy", nativeQuery = true)
    List<Object> customAction(@Param("date") Date date,
                              @Param("value") Double value,
                              @Param("status") String status,
                              @Param("orderBy") String orderBy);
}
